/* 페이징 관련 변수 */
let webMainBannerTotalCount   = 0;
let webMainBannerTotalPages   = 0;

/*aggird*/
let webMainBannerAgGridData = [];

let webMainBannerSelectId = "";

/****************************************************************************
 * 검색 날짜 설정
 //(A:오늘, B:3일, C:7일, D:최근30일, E:최근90일, F:이번달, G:올해, H:지난주, I:지난달)
 ****************************************************************************/
function fn_webMainBannerSetDate(param){
    if("A"==param){
        // 오늘
        let toDate = new Date();
        let year  = toDate.getFullYear();
        let month = toDate.getMonth() + 1;
        let day   = toDate.getDate();

        if(month < 10) month = "0" + month;
        if(day < 10) day = "0" + day;

        webMainBannerSearchStartDate = year+'-'+month+'-'+day;
        webMainBannerSearchEndDate   = year+'-'+month+'-'+day;
    }
    else if("B"==param){
        // 3일
        // 검색 종료일자
        let toDate = new Date();
        let year  = toDate.getFullYear();
        let month = toDate.getMonth() + 1;
        let day   = toDate.getDate();

        if(month < 10) month = "0" + month;
        if(day < 10) day = "0" + day;

        webMainBannerSearchEndDate   = year+'-'+month+'-'+day;

        // 검색 시작일자
        toDate.setDate(toDate.getDate() - 3);
        year  = toDate.getFullYear();
        month = toDate.getMonth() + 1;
        day   = toDate.getDate();

        if(month < 10) month = "0" + month;
        if(day < 10) day = "0" + day;

        webMainBannerSearchStartDate = year+'-'+month+'-'+day;
    }
    else if("C"==param){
        // 이번주
        // 검색 종료일자
        let toDate = new Date();
        let year  = toDate.getFullYear();
        let month = toDate.getMonth() + 1;
        let day   = toDate.getDate();

        if(month < 10) month = "0" + month;
        if(day < 10) day = "0" + day;

        webMainBannerSearchEndDate   = year+'-'+month+'-'+day;

        // 검색 시작일자
        toDate.setDate(toDate.getDate() - 7);
        year  = toDate.getFullYear();
        month = toDate.getMonth() + 1;
        day   = toDate.getDate();

        if(month < 10) month = "0" + month;
        if(day < 10) day = "0" + day;

        webMainBannerSearchStartDate = year+'-'+month+'-'+day;
    }
    else if("D"==param){
        // 최근30일
        let toDate = new Date();
        let year  = toDate.getFullYear();
        let month = toDate.getMonth() + 1;
        let day   = toDate.getDate();

        if(month < 10) month = "0" + month;
        if(day < 10) day = "0" + day;

        //최근30일
        toDate.setDate(toDate.getDate() - 30);
        startYear  = toDate.getFullYear();
        startMonth = toDate.getMonth() + 1;
        startDay   = toDate.getDate();

        if(startMonth < 10) startMonth = "0" + startMonth;
        if(startDay < 10) startDay = "0" + startDay;

        webMainBannerSearchStartDate = startYear+'-'+startMonth+'-'+startDay;
        webMainBannerSearchEndDate   = year+'-'+month+'-'+day;

    }
    else if("E"==param){
        // 최근90일
        // 검색 종료일자
        let toDate = new Date();
        let year  = toDate.getFullYear();
        let month = toDate.getMonth() + 1;
        let day   = toDate.getDate();

        if(month < 10) month = "0" + month;
        if(day < 10) day = "0" + day;

        webMainBannerSearchEndDate   = year+'-'+month+'-'+day;

        // 검색 시작일자
        toDate.setDate(toDate.getDate() - 90);
        year  = toDate.getFullYear();
        month = toDate.getMonth() + 1;
        day   = toDate.getDate();

        if(month < 10) month = "0" + month;
        if(day < 10) day = "0" + day;

        webMainBannerSearchStartDate = year+'-'+month+'-'+day;
    }
    else if("F"==param){
        //F:이번달
        // 검색 종료일자
        let toDate = new Date();
        let year  = toDate.getFullYear();
        let month = toDate.getMonth() + 1;
        let day   = toDate.getDate();

        if(month < 10) month = "0" + month;
        if(day < 10) day = "0" + day;

        webMainBannerSearchEndDate   = year+'-'+month+'-'+day;

        // 검색 시작일자
        webMainBannerSearchStartDate = year+'-'+month+'-01';
    }
    else if("G"==param){
        // G:올해
        // 검색 종료일자
        let toDate = new Date();
        let year  = toDate.getFullYear();
        let month = toDate.getMonth() + 1;
        let day   = toDate.getDate();

        if(month < 10) month = "0" + month;
        if(day < 10) day = "0" + day;

        webMainBannerSearchEndDate   = year+'-'+month+'-'+day;

        // 검색 시작일자
        webMainBannerSearchStartDate = year+'-01-01';
    }
    else if("H"==param){
        // H:지난주, I:지난달
        // 검색 종료일자
        let toDate = new Date();
        let year  = toDate.getFullYear();
        let month = toDate.getMonth() + 1;
        let day   = toDate.getDate();

        if(month < 10) month = "0" + month;
        if(day < 10) day = "0" + day;

        webMainBannerSearchEndDate   = year+'-'+month+'-'+day;

        // 검색 시작일자
        webMainBannerSearchStartDate = year+'-01-01';
    }
    else if("I"==param){
        // I:지난달
        // 검색 종료일자
        let toDate = new Date();
        let year  = toDate.getFullYear();
        let month = toDate.getMonth() + 1;
        let day   = toDate.getDate();

        if(month < 10) month = "0" + month;
        if(day < 10) day = "0" + day;

        webMainBannerSearchEndDate   = year+'-'+month+'-'+day;

        // 검색 시작일자
        webMainBannerSearchStartDate = year+'-01-01';
    }

    $("#webMainBannerSearchStartDate").val(webMainBannerSearchStartDate).trigger("change");
    $("#webMainBannerSearchEndDate").val(webMainBannerSearchEndDate).trigger("change");
}


/****************************************************************************
 * 메인 배너 정보 리스트 조회
 ****************************************************************************/
function fn_selectListWebMainBannerJson(){
    let formData = new FormData();
    formData.append("menuClass", menuClass);
    formData.append("webMainBannerSearchKeywordParam", webMainBannerSearchKeywordParam);
    formData.append("webMainBannerSearchType", webMainBannerSearchType);
    formData.append("webMainBannerSort", webMainBannerSort);
    formData.append("webMainBannerDir", webMainBannerDir);
    formData.append("webMainBannerStart", webMainBannerStart);
    formData.append("webMainBannerLimit", webMainBannerLimit);
    formData.append("webMainBannerSearchStartDate", webMainBannerSearchStartDate);
    formData.append("webMainBannerSearchEndDate", webMainBannerSearchEndDate);
    formData.append("webMainBannerSearchDateType", webMainBannerSearchDateType);

    $.ajax({
        url: encodeURI('/webmainbanner/selectListWebMainBanner.do'),
        data: formData,
        dataType: "json",
        processData: false,
        contentType: false,
        type: 'POST',
        async: true,
        success: function(data){
            if('0'==data.msgCode){
                // 페이징 처리
                webMainBannerTotalCount  = data.totalCount;
                //$("#txt_noticeTotalCount").text(noticeTotalCount);

                webMainBannerTotalPages = Math.ceil(webMainBannerTotalCount/webMainBannerLimit);

                // 리스트 조회
				webMainBannerAgGridData = data.rows.map(row => {
				                    if(row.filePath2) {
				                        return { ...row, filePath2: CDN_URL + row.filePath2.replace(/^C:/, "") };
				                    }
				                    return row;
				                });
                webMainBannerGridOptions.api.setRowData(webMainBannerAgGridData);
				
			
                if(0<data.rows.length){
                    //페이징 처리
                    window.pagObj = $('#webMainBannerPagination').twbsPagination({
                        startPage    : ((webMainBannerStart/webMainBannerLimit)+1),
                        totalPages   : (webMainBannerTotalPages==0)?1:webMainBannerTotalPages,
                        visiblePages : 10,
                        initiateStartPageClick: false,
                        prev         : '<img src="/image/web/page_navigation_arrow.svg" alt="prev"/>',
                        next         : '<img src="/image/web/page_navigation_arrow.svg" alt="next"/>',
                        first        : '',
                        last         : '',
                        onPageClick: function (event, page) {
                            fn_webMainBannerPagination(page);
                        }
                    }).on('page', function (event, page) {
                        //console.info(page + ' (from event listening)');
                    });
                }
                else{

                }
            }
            else{
                modalEvent.danger("조회 오류", data.msgDesc);
            }
        },
        error : function(xhr, status, error) {
            modalEvent.danger("조회 오류", "조회 중 오류가 발생하였습니다. 잠시후 다시시도하십시오.");
        },
        beforeSend:function(){
            // 로딩열기
            webMainBannerGridOptions.api.showLoadingOverlay();
        },
        complete:function(){

        }
    });
}

/****************************************************************************
 * 검색하기
 ****************************************************************************/
function fn_webMainBannerSearch(param){
    if("A"!=param && "Y"!=selectUseYn){
        modalEvent.warning("", "조회 권한이 없습니다.");
        return false;
    }

    fn_webMainBannerPaginReset();

    webMainBannerSearchKeywordParam = $("#webMainBannerSearchKeyword").val();

    webMainBannerSearchType = $("#webMainBannerSearchType").val();

    webMainBannerSearchDateType  = $("#webMainBannerSearchDateType").val();
    webMainBannerSearchStartDate = $("#webMainBannerSearchStartDate").val();
    webMainBannerSearchEndDate   = $("#webMainBannerSearchEndDate").val();

    fn_selectListWebMainBannerJson();
}


/****************************************************************************
 * 초기화하기
 ****************************************************************************/
function fn_webMainBannerReset(){
    fn_webMainBannerSetDate('D');
    $("#webMainBannerSearchDateType option:eq(0)").prop("selected", true);

    $("#webMainBannerSearchKeyword").val("");

    fn_webMainBannerSearch();
}

/****************************************************************************
 * 페이징 처리
 ****************************************************************************/
function fn_webMainBannerPagination(param){
    webMainBannerStart = (parseInt(param)-1)*webMainBannerLimit;

    fn_selectListWebMainBannerJson();
}

/****************************************************************************
 * 페이징 리셋
 ****************************************************************************/
function fn_webMainBannerPaginReset(){
    webMainBannerSearchKeywordParam = '';

    webMainBannerStart        = 0;
    webMainBannerLimit        = 100;
    webMainBannerTotalCount   = 0;
    webMainBannerTotalPages   = 0;

    //페이징 초기화
    if($("#webMainBannerPagination").data("twbs-pagination")){
        $("#webMainBannerPagination").twbsPagination("destroy");
    }
}

/****************************************************************************
 * 메인 배너 삭제
 ****************************************************************************/
function fn_deleteWebMainBanner(){
    if("Y"!=deleteUseYn){
        modalEvent.warning("", "삭제 권한이 없습니다.");
        return false;
    }

    if(!webMainBannerSelectId){
        modalEvent.warning("", "삭제할 대상을 선택하세요.");
        return false;
    }

    modalEvent.info("삭제", "선택한 메인 배너 정보를 삭제하시겠습니까?", function(){
        let formData = new FormData();
        formData.append("menuClass", menuClass);
        formData.append("selectId", webMainBannerSelectId);

        $.ajax({
            url: encodeURI('/webmainbanner/deleteWebMainBanner.do'),
            data: formData,
            dataType: "json",
            processData: false,
            contentType: false,
            type: 'POST',
            async: true,
            success: function(data){
                if('0'==data.msgCode){
                    modalEvent.success("삭제 성공", data.msgDesc, function(){
                        fn_webMainBannerOk();
                    });
                }
                else{
                    modalEvent.danger("삭제 오류", data.msgDesc);
                }
            },
            error : function(xhr, status, error) {
                modalEvent.danger("삭제 오류", "삭제 중 오류가 발생하였습니다. 잠시후 다시시도하십시오.");
            },
            beforeSend:function(){

            },
            complete:function(){

            }
        });
    });
}

/****************************************************************************
 * 검색 엔터 이벤트
 ****************************************************************************/
function fn_webMainBannerEnter(e){
    if(e.which){
        // 파이어폭스
        if(13 == e.which) {
            //로그인 액션 스크립트
            fn_webMainBannerSearch();
        }
    }
    else{
        // 윈도우, 사파리, 크롬
        if(13 == event.keyCode) {
            //로그인 액션 스크립트
            fn_webMainBannerSearch();
        }
    }
}

/****************************************************************************
 * 정렬 이벤트
 ****************************************************************************/
function fn_alignContent(param, param2){
    let align = "";

    if("A"==param){
        align = "오늘";

        fn_webMainBannerSetDate('A');
    }
    else if("B"==param){
        align = "최근30일";

        fn_webMainBannerSetDate('D');
    }
    else if("C"==param){
        align = "최근90일";

        fn_webMainBannerSetDate('E');
    }
    else if("D"==param){
        align = "이번주";

        fn_webMainBannerSetDate('C');
    }
    else if("E"==param){
        align = "이번달";

        fn_webMainBannerSetDate('F');
    }
    else if("F"==param){
        align = "올해";

        fn_webMainBannerSetDate('G');
    }
    else if("G"==param){
        align = "지난주";

        fn_webMainBannerSetDate('H');
    }
    else if("H"==param){
        align = "지난달";

        fn_webMainBannerSetDate('I');
    }
    else{
        align = "";
    }
    $("#webMainBannerSearchDateType").val(param);
    $("#webMainBannerSearchDateType").siblings("button").text(align);
}

/****************************************************************************
 * 완료
 ****************************************************************************/
function fn_webMainBannerOk(){
    fn_webMainBannerReset();
}

/****************************************************************************
 * 등록 화면으로 이동.
 ****************************************************************************/
function fn_insertWebMainBannerIntro(){
    if("Y"==insertUseYn){
        let pagingParam = "?menuClass="+menuClass;
        fn_leftFormAction("/webmainbanner/insertWebMainBannerIntro.do"+pagingParam);
    }else{
        modalEvent.warning("", "등록 권한이 없습니다.");
        return false;
    }

}

/****************************************************************************
 * 수정 화면으로 이동.
 ****************************************************************************/
function fn_updateWebMainBannerIntro(muWebMainBannerId){
    if("Y"==updateUseYn){
        let pagingParam = "?menuClass="+menuClass;
        pagingParam    += "&muWebMainBannerId="+muWebMainBannerId;
        fn_leftFormAction("/webmainbanner/updateWebMainBannerIntro.do"+pagingParam);
    }else{
        modalEvent.warning("", "수정 권한이 없습니다.");
        return false;
    }
}
function thumbnailCellRenderer(params) {
    if(!params.value)
        return
    else
        return `<img src="${params.value.replace("C:", "")}" width="40" height="40" alt="Thumbnail">`;
}

let webMainBannerColumnDefs = [
    {field: "checkbox", headerName:"", minWidth:55, maxWidth:55, headerCheckboxSelection: true, checkboxSelection: true},
    /* {field: "rowNum", headerName:"번호", minWidth:80,maxWidth:80, sortable: false}, */
    {field: "rowNum", headerName:"번호", minWidth:60, maxWidth:60,sortable: false, cellStyle:{textAlign: 'center'}},
    {field: "bannerType", headerName:"구분", minWidth:200},
    {field: "filePath2", headerName:"섬네일", minWidth:100, cellRenderer: thumbnailCellRenderer},
    {field: "title", headerName:"제목", minWidth:250, cellStyle:{cursor: 'pointer', color:'#3985EA'}},
    // {field: "content", headerName:"내용",minWidth:500},
    {field: "writeDate", headerName:"등록일",minWidth:150, maxWidth:150},
    {field: "writeName", headerName:"작성자",minWidth:150, maxWidth:150},
];

// let the grid know which columns and what data to use
let webMainBannerGridOptions = {
    suppressRowTransform: true,
    columnDefs: webMainBannerColumnDefs,
    defaultColDef: {		// 리스트 기본 설정
        flex: 1,
        sortable: true,		//정렬 여부
        resizable: true,	//리사이즈
        editable: true,	// 그리드에서 데이터 수정
        cellStyle:{textAlign:'left',fontSize:'14px',padding:'0'},
        //suppressSizeToFit:true,		//자동 맞춤
        //enableRowGroup: true,		// 그룹 묶음
        enablePivot: true,
        enableValue : true
    },
    //suppressMultiSort:true,  //단일솔트 true가 단일, false가 다중 shift + sort 시
    headerHeight : 41, // header 높이
    rowHeight : 41, // row 높이
    rowData : webMainBannerAgGridData,
    suppressRowClickSelection : true, // 로우 클릭시 체크박스 선택 true no, false yes
    localeText : {
        noRowsToShow : '조회 결과가 없습니다.'
    }, //데이터 없을 시 나오는 문구
    rowSelection : 'multiple', // row 다중 선택
    debug : false,
    onCellClicked: function(event){ //셀 클릭 이벤트
        /* alert(event.column.colId); */
        if('title'==event.column.colId){
            fn_updateWebMainBannerIntro(event.data.muWebMainBannerId);
        }
    },
    onSelectionChanged: function(event){ //체크박스 선택
        let selectRows = [];
        selectRows = event.api.getSelectedRows();

        webMainBannerSelectId = '';
        for(let i=0; i<selectRows.length; i++){
            webMainBannerSelectId += selectRows[i].muWebMainBannerId + ",";
        }
        webMainBannerSelectId = webMainBannerSelectId.substring(0, webMainBannerSelectId.lastIndexOf(','));
    },
    onSortChanged: function(event){
        //정렬
        webMainBannerSort = ''; //기존 정렬 초기화
        let columnArr = event.columnApi.getColumnState();
        if(0<columnArr.length){
            //sort index 순으로 재정렬
            columnArr.sort(function(a,b){
                return a.sortIndex - b.sortIndex;
            });

            let nullCnt = 0;
            for(let i=0; i<columnArr.length; i++){
                let gridSortModel = columnArr[i].colId;
                let gridSort = columnArr[i].sort;

                if(gridSort != null){
                    webMainBannerStart = 0;
                    webMainBannerSort += gridSortModel+' '+ gridSort + ',';
                }
                else{
                    nullCnt++;
                    if(nullCnt == columnArr.length){
                        webMainBannerSort = '';
                        webMainBannerDir = '';
                        webMainBannerStart = 0;
                    }
                }
            }
        }
        webMainBannerSort = webMainBannerSort.substring(0,webMainBannerSort.lastIndexOf( ",")); //맨끝 콤마 지우기

        fn_webMainBannerSearch();
    }
};

// lookup the container we want the Grid to use
let webMainBannerGridDiv = document.querySelector('#webMainBannerGrid');

// create the grid passing in the div to use together with the columns & data we want to use
new agGrid.Grid(webMainBannerGridDiv, webMainBannerGridOptions);





/****************************************************************************
 * 페이지 init
 ****************************************************************************/
function fn_pageInit(){
    // 날짜 datepicker
    fn_searchDatePicker("#divWebMainBannerSearchStartDate", "#divWebMainBannerSearchEndDate");

    if(!webMainBannerSearchStartDate&&!webMainBannerSearchEndDate){
        // 검색 오늘날짜 셋팅
        fn_webMainBannerSetDate('D');
    }else{
        $("#webMainBannerSearchStartDate").val(webMainBannerSearchStartDate).trigger("change");
        $("#webMainBannerSearchEndDate").val(webMainBannerSearchEndDate).trigger("change");
    }

    // 초기 페이징 처리
    $("#webMainBannerSearchKeyword").val(webMainBannerSearchKeywordParam);

    fn_webMainBannerSearch("A");
}

/****************************************************************************
 * 페이지 event
 ****************************************************************************/
function fn_pageEvent(){
    // 검색 input
    $(document).on('keypress', '#webMainBannerSearchKeyword', function(e) {
        fn_webMainBannerEnter(e);
    });

    // 검색 조회 버튼
    $("#btnSearchWebMainBanner").click(function () {
        fn_webMainBannerSearch();
    });

    // 메인 배너 등록 팝업 버튼
    $("#btnInsertWebMainBanner").click(function () {
        fn_insertWebMainBannerIntro();
    });

    // 메인 배너 삭제 버튼
    $("#btnDeleteWebMainBanner").click(function () {
        fn_deleteWebMainBanner();
    });

    // 기간 선택 콤보 이벤트
    const target = $("#webMainBannerSearchDateType").siblings("ul.select_option_list");
    target.find("li.option_list_item").click(function () {
        let selectIdArr = $(this).prop("id").split('_');
        let selectId    = selectIdArr[1];
        let selectName  = $(this).text();

        $(this).parent().siblings("button").text(selectName);
        $(this).parent().siblings("input").val(selectId);

        fn_alignContent(selectId);
    });
    
    // 카테고리 선택 콤보 이벤트
    const categoryTarget = $("#webMainBannerSearchType").siblings("ul.select_option_list");
    categoryTarget.find("li.option_list_item").click(function () {
        let selectIdArr = $(this).prop("id").split('_');
        let selectId    = selectIdArr[1];
        let selectName  = $(this).text();

        if(selectId.match("ALL")){
            selectId = '';
        }
        $(this).parent().siblings("button").text(selectName);
        $(this).parent().siblings("input").val(selectId);
    });
}

$(function(){
    // 페이지 init
    fn_pageInit();

    // 페이지 event
    fn_pageEvent();
});